using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace WrapperClass
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(528, 320);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(184, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(184, 23);
			this.button1.TabIndex = 4;
			this.button1.Text = "DataSource =  Custom Collection";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// button2
			// 
			this.button2.Location = new System.Drawing.Point(16, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(160, 23);
			this.button2.TabIndex = 5;
			this.button2.Text = "DataSource = DataTable";
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button3
			// 
			this.button3.Location = new System.Drawing.Point(376, 8);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(120, 23);
			this.button3.TabIndex = 6;
			this.button3.Text = "Reset Datasource";
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 382);
			this.Controls.Add(this.button3);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//just so a singleclick sorts
			this.gridDataBoundGrid1.SortBehavior = GridSortBehavior.SingleClick;
			 this.gridDataBoundGrid1.CellClick += new GridCellClickEventHandler(gridDataBoundGrid1_CellClick);
		}

		
		//set a MyObject list as the datasource
		private void button1_Click(object sender, System.EventArgs e)
		{
			try
			{
				IList aList = MyObject.CreateMyObjectList(30);
				SetDataSource(aList);
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		//set a DataTable as the datasource
		private void button2_Click(object sender, System.EventArgs e)
		{
			try
			{
				DataTable dt = CreateDataTable();
				SetDataSource(dt);
			}
			catch(Exception ex)
			{
				MessageBox.Show(ex.Message);
			}
		}

		//set either a Datatable or IList as datasource
		private void SetDataSource(object dataSource)
		{
			ListWrapper lw = this.gridDataBoundGrid1.DataSource as ListWrapper;
			if(lw != null)
				lw.UnWireGrid(this.gridDataBoundGrid1);
			lw = dataSource is DataTable ? new ListWrapper((DataTable)dataSource) : new ListWrapper((IList)dataSource);
			this.gridDataBoundGrid1.DataSource = lw;
			lw.WireGrid(gridDataBoundGrid1); // to tie in the UI

			//just for timing purposes
			lw.SortStarting += new EventHandler(lw_SortStarting);
			lw.SortCompleted += new EventHandler(lw_SortCompleted);
		}

		#region create sample datatable
		private DataTable CreateDataTable()
		{
			string[] numberStrings = new string[]{"zero","one","two","three","four","five","six","seven","eight","nine"};
		
			DataTable dt = new DataTable("table");
			dt.Columns.Add("ID", typeof(int));
			dt.Columns.Add("I", typeof(int));
			dt.Columns.Add("S", typeof(string));
			dt.Columns.Add("D", typeof(DateTime));

			Random r = new Random();
			for(int i = 0; i < 30; ++i)
			{
				int j = r.Next(10);
				DataRow dr = dt.NewRow();
				dr["ID"] = i;
				dr["I"] = j;
				dr["S"] = numberStrings[j];
				dr["D"] = DateTime.Now.AddDays(10-r.Next(20)).Date;
				dt.Rows.Add(dr);
			}

			return dt;
		}
		#endregion

		#region Time Sort
		DateTime start;
		private void lw_SortStarting(object sender, EventArgs e)
		{
			start = DateTime.Now;
		}

		private void lw_SortCompleted(object sender, EventArgs e)
		{
			ListWrapper lw = sender as ListWrapper;
		   this.Text = string.Format("time= {0} secs   sortString= {1}", ((TimeSpan)(DateTime.Now-start)).TotalSeconds, lw.SortString);
		}
		#endregion

		private void gridDataBoundGrid1_CellClick(object sender, GridCellClickEventArgs e)
		{
			if(e.ColIndex == 0 && e.RowIndex > 0)
			{
				ListWrapper lw = this.gridDataBoundGrid1.DataSource as ListWrapper;
				for(int i = 1; i <= 5; ++i)
				{
					lw.RemoveAt(e.RowIndex);
				}
				this.gridDataBoundGrid1.Refresh();
			}
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			ListWrapper lw = this.gridDataBoundGrid1.DataSource as ListWrapper;
			lw.ResetList();
			this.gridDataBoundGrid1.Refresh();
		}
	}

	#region MyObject class
	public class MyObject
	{
		/// <summary>
		/// Used to create sample IList holding MyObject objects.
		/// </summary>
		/// <param name="nItems">number of objects</param>
		/// <returns>an IList holding MyObjects</returns>
		public static MyObject[] CreateMyObjectList(int nItems)
		{
			string[] numberStrings = new string[]{"zero","one","two","three","four","five","six","seven","eight","nine"};
			MyObject[] list = new MyObject[nItems];
			Random r = new Random(62345678);
			for(int i = 0; i < nItems; ++i)
			{
				int j = r.Next(10);
				//list[i] = new MyObject(numberStrings[j], j, DateTime.Now.AddDays(j).Date);
				list[i] = new MyObject(numberStrings[j], j, DateTime.Now.AddDays(10-r.Next(20)).Date);
				list[i].id = i;
			}
			return list;
		}

		int id = -1;
		string s = "";
		int i = 0;
        DateTime d = DateTime.MinValue;

		public MyObject(string s, int i, DateTime d)
		{
			this.s = s;
			this.i = i;
			this.d = d;
		}

	
		public string S
		{
			get{return s;}
			set{s = value;}
		}

		public int I
		{
			get{return i;}
			set{i = value;}
		}

		public DateTime D
		{
			get{return d;}
			set{d = value;}
		}

		public int ID
		{
			get{return id;}
			set{id = value;}
		}
	}
	#endregion
	
}
